# gcp::Reaction Class Reference

Chemical reaction class. More...

`#include <gcp/reaction.h>`

Inheritance diagram for gcp::Reaction:

List of all members.

## Public Member Functions

| Reaction ()
virtual | ~Reaction ()
bool | Build (std::list< gcu::Object * > &Children) throw (std::invalid_argument)
void | Transform2D (gcu::Matrix2D &m, double x, double y)
bool | BuildContextualMenu (GtkUIManager *UIManager, gcu::Object *object, double x, double y)
bool | OnSignal (gcu::SignalId Signal, gcu::Object *Child)
bool | Load (xmlNodePtr node)
double | GetYAlign ()

## Detailed Description

Chemical reaction class.

This class is used for chemical reactions in GChemPaint. It can represent a whole reactions scheme with several steps, although only one step is currently really supported. Acceptable children for an instance of this class are instances of ReactionArrow and ReactionStep.

Definition at line 42 of file reaction.h.

## Constructor & Destructor Documentation

gcp::Reaction::Reaction | ( |  | ) |

Constructs a new empty Reaction instance.

virtual gcp::Reaction::~Reaction | ( |  | ) | `[virtual]`

The destructor.

## Member Function Documentation

bool gcp::Reaction::Build | ( | std::list< gcu::Object * > & | Children | ) | throw (std::invalid_argument)`[virtual]`

Parameters:

  | Children | the list of objects used as children to build the reaction

This method is called to build a reactiont from its children. It might fail if reactants are not properly aligned with the reaction arrows. Accepted children are molecules and texts to be used as reactants or products, and reaction arrows.

Returns:
  true in case of success and false if failed.

Reimplemented from gcu::Object.

void gcp::Reaction::Transform2D | ( | gcu::Matrix2D & | m,
|  | double | x,
|  | double | y |
| ) |  |  | `[virtual]`

Parameters:

  | m | the Matrix2D of the transformation.
  | x | the x component of the center of the transformation.
  | y | the y component of the center of the transformation.

Used to move and/or transform an object. This virtual method must be overrided by Object derived classes for which it makes sense. The base Object class has no coordinates and the default method calls the corresponding method for every child.

Reimplemented from gcu::Object.

bool gcp::Reaction::BuildContextualMenu | ( | GtkUIManager * | UIManager,
|  | gcu::Object * | object,
|  | double | x,
|  | double | y |
| ) |  |  | `[virtual]`

Parameters:

  | UIManager | the GtkUIManager to populate.
  | object | the Object on which occured the mouse click.
  | x | x coordinate of the mouse click.
  | y | y coordinate of the mouse click.

This method is called to build a contextual menu for the reaction.

Returns:
  true if something is added to the UIManager, false otherwise.

Reimplemented from gcu::Object.

bool gcp::Reaction::OnSignal | ( | gcu::SignalId | Signal,
|  | gcu::Object * | Child |
| ) |  |  | `[virtual]`

Parameters:

  | Signal | the appropriate SignalId
  | Child | the child which emitted the signal or NULL

This function is called by the framework when a signal has been emitted for the reaction, when one of its children changed. It should not be called by a program; call Object::EmitSignal instead.

Returns:
  true if the signal should be propagated to the parent, false otherwise.

Reimplemented from gcu::Object.

bool gcp::Reaction::Load | ( | xmlNodePtr | node | ) | `[virtual]`

Parameters:

  | node,: | a pointer to the xmlNode containing the serialized reaction.

Used to load an reaction in memory.

Returns:
  true on succes, false otherwise.

Reimplemented from gcu::Object.

double gcp::Reaction::GetYAlign | ( |  | ) | `[virtual]`

Used to retrieve the y coordinate for alignment.

Returns:
  y coordinate used for the reaction alignment.

Reimplemented from gcu::Object.

The documentation for this class was generated from the following file:

- reaction.h